% Mfile read_pos_data.m
%
% Mfile to read and display data collected with the NXT brick
%
% Written by:  J. E. Michaels, 13-Apr-2008

% open file and read data
fd = fopen('pos_data');
vector = fread(fd, inf, 'uint16');
fclose(fd);
data = reshape(vector', 4, length(vector)/4)';
times      = data(1:end,1);
target_pos = data(1:end,2);
real_pos   = data(1:end,3);
mot_cmd    = data(1:end,4);

% adjust values for 16 bit data
if( abs(times(end)-times(1))>20000)
    idx = find( times > 32767);
    times(idx) = times(idx)-65536;
end
indx = find( target_pos > 32767);
target_pos(indx) = target_pos(indx) - 65536;
indx = find( real_pos > 32767);
real_pos(indx) = real_pos(indx) - 65536;
indx = find( mot_cmd > 32767);
mot_cmd(indx) = mot_cmd(indx) - 65536;

% plot real position and target position
times_sec  = (times-times(1))/1000;
times_sec = times_sec - 0.2;
%figure
subplot(211)
plot(times_sec,target_pos, 'k--',times_sec,real_pos, 'k');
xlabel('Time (sec)')
ylabel('Position (degrees)')
legend('Reference','Actual')

plot motor command
figure
plot(times_sec, mot_cmd)
grid on
xlabel('Time (sec)')
ylabel('Motor Command')
